--- debmirror-	2019-03-23 06:40:44.000000000 -0400
+++ debmirror	2021-04-16 01:59:21.317590725 -0400
@@ -644,9 +644,11 @@ our $debmarshal=0;
 our $disable_ssl_verification;
 our $retry_rsync_packages=1;
 our $slow_cpu=0;
+our $ignore_arch_all=0;
 our $check_gpg=1;
 our $new_mirror=0;
 our $retry_rsync_packages_delay=30; # seconds
+
 my @errlog;
 my $HOME;
 ($HOME = $ENV{'HOME'}) or die "HOME not defined in environment!\n";
@@ -767,6 +769,7 @@ GetOptions('debug'                  => \
            'allow-dist-rename'      => \$allow_dist_rename,
            'debmarshal'             => \$debmarshal,
            'slow-cpu'               => \$slow_cpu,
+           'ignore-arch-all'        => \$ignore_arch_all,
            'disable-ssl-verification' => \$disable_ssl_verification,
            'retry-rsync-packages=s' => \$retry_rsync_packages,
            'keyring=s'              => \@keyrings,
@@ -1093,6 +1096,7 @@ foreach my $dist (keys %distset) {
   next unless exists $distset{$dist}{mirror};
   foreach my $section (@sections) {
     foreach my $arch (@arches, "all") {
+      next if $arch eq 'all' and $ignore_arch_all;
       add_bytes("dists/$dist/$section/binary-$arch/Packages");
       add_bytes("dists/$dist/$section/binary-$arch/Packages.gz");
       add_bytes("dists/$dist/$section/binary-$arch/Packages.xz");
@@ -1123,6 +1127,7 @@ foreach my $dist (keys %distset) {
     # some suites don't have d-i
     next if ($section =~ /debian-installer/ && di_skip_dist($dist) );
     foreach my $arch (@arches, "all") {
+      next if $arch eq 'all' and $ignore_arch_all;
       get_index("dists/$dist/$section/binary-$arch", "Packages");
       link_index($dist,$section,$arch) if $debmarshal;
     }
@@ -1198,7 +1203,12 @@ say("Parsing Packages and Sources files
 
   my $empty_mirror = 1;
 
-  my %arches = map { $_ => 1 } (@arches, "all");
+  my %arches;
+  if ($ignore_arch_all) {
+    %arches = map { $_ => 1 } (@arches);
+  } else {
+    %arches = map { $_ => 1 } (@arches, "all");
+  }
 
   my $include = "(".join("|", @includes).")" if @includes;
   my $exclude = "(".join("|", @excludes).")" if @excludes;
@@ -3267,6 +3277,7 @@ sub do_contents_for_each_dist_arch_sect
     next if $dist=~/\bexperimental\b|-proposed-updates\b/o;
     next unless exists $distset{$dist}{mirror};
     foreach my $arch (@arches, "all") {
+      next if $arch eq 'all' and $ignore_arch_all;
       my %op_params = %$operational_params;
       $op_params{is_source} = $arch=~/\bsource\b/o;
       unless ($op_params{is_source} && !$op_params{do_for_source}) {
